\ Feillikningar: danning og akkumulering i normallikningssettet
\ --------------------------------------------------------------

VARIABLE sumpvv			\ feilkvadratsum, ikkje oppskalert
VARIABLE etal			\ antal element=ukjente

\ oppskalering: hside og vside må oppskalerast likt!
\ lengdefeillikningar og retningsfeillikningar også likt
\ skalafaktoren går inn i normallikningane, her i 2. potens!
\ Når venstresida av normallikningane blir brukt til kvalitetslikningar
\ må hsida skalerast under oppstilling, med skalafaktor i 2 potens!

6 VALUE #ko  \ antall koeff + konstantledd, x y x y o f
#ko INTEGER ARRAY FE{		\ koeffisientar i ei feillikning
#ko INTEGER ARRAY IN{		\ indeksar i ei feillikning

: 0feillikn ( -- ) \ nullstill feillikning
	#ko 0 DO  0 FE{ I } !   0 IN{ I } !  LOOP ;

\ siktdata, frå provisoriske xy-koo
variable L0
2variable sin0 \ som brøk
2variable cos0 \ som brøk

100 VALUE feillikningsskala
: +skaler ( n -- n' ) feillikningsskala * ;

: -skaler ( n' -- n ) feillikningsskala / ;

\ for xy
: !KooKoeffR ( a b -- )     \ set forteikn og lagra retn-koeff for endepunkta
	2dup  ( a b a b )
	NEGATE   FE{ 1 } !          FE{ 0 } ! ( a b )    \ for stasjonspkt
	( a b )  FE{ 3 } !  NEGATE  FE{ 2 } ! ;          \ for tilsikta pkt 
	
: !KooKoeffL ( a b -- )     \ set forteikn og lagra lengd-koeff for endepunkta
	2dup  ( a b a b )
	NEGATE   FE{ 1 } !  NEGATE  FE{ 0 } ! ( a b )    \ for stasjonspkt
	( a b )  FE{ 3 } !          FE{ 2 } ! ;          \ for tilsikta pkt 

: siktdata ( snr -- ) \ L og retn koo-koo
	koo-diff 2dup 2>R  hypotenus3 dup L0 ! ( L )
	dup 2R> ( L L dx dy )
	rot sin0 2! ( L dx ) 
	swap cos0 2! ;

\ for h --------------------------

: JRkorreksjon ( l -- korr ) \ frå hdiff-basert til obs
	JR 10000 e/m @ * */ ;           \ negativ frå obs

: ah1 ( Ls Lko -- a )          \ ro*sinz*sinz/L omforma til
	SWAP 2>R                   \ ro*Lko*Lko/L*L*L
	roi 2R@ */
	2R@ */
	feillikningsskala 2R> drop */ ;

: siktdatah ( snr -- z0 koeff )
	dup siktdata         \ Lkoo lagra som L0
	hdiff ( dh )         \ frå h-ar og i-s
	L0 @ swap over R>P ( Lkoo Lskr z0 )
	over JRkorreksjon +
	rot rot      ( z0 Lkoo Lskr )   \ cc
	swap ah1 ;

: roi/L ( L -- roi/L ) roi  +skaler swap 0 swap um/mod nip ;

\ ---------------------------------
\ retningslikningar
\ Retningsfeillikning
\ v=ax1-by1-ax2+by2-z+(RVprov-OEprov-HVmålt)
\ v er funksjon av 6 element, xy-koo i kvar ende av siktet,
\ orienteringselementet (z) og diff mellom målt HV og HV (f)
\ utrekna av provisoriske koo og provisorisk orientering.
\ etal er antal element, f er konstanledd (RVprov-OEprov-HVmålt).
\ Koeffisisenten for z er alltid -1.

\ Feillikningar struktur -----------------
\    	   0    1    2    3    4    5
\ IN{	| ex | ey | ex | ey | ez | etal |
\ FE{	| a1 | b1 | a2 | b2 | -1 |  f   |
\ vekt: variable P

\ I normallikningane, venstreside pr linje: 
\ kolonne 0-3 treng 2 plassar pr nypkt
\ Kolonne 4 treng 1 plass pr orientering

\ rå koeffisientar, for tilsikta pkt
: RetningsKoeff ( -- a b )  \ i oppskalerte ( i roi/L) trig-einingar
	L0 @  roi/L 
	dup  sin0 2@ */
	swap cos0 2@ */
	;

: OE@ ( snr -- oe ) \ orienteringselement
	ORNR{ swap } @  OE{ swap } @ ;

: RetningsKonst ( snr -- konstantledd ) \ xi trig-einingar
	HV{ over } @    \ >einingTrig
	over OE@      +   \ >einingTrig  +
	swap siktretn -
	normaliser0 ;    \ +-200
	
\ Orienteringskoeff= -1 , alltid (uskalert)

\ Lengdelikningar ---------------------------------------------
\ Feillikningskoeffisientane i lengdelikningar er alltid mindre enn
\ ein (cos og sin), og må difor oppskalerast for ikkje å gå i null.
\ Normallikningane blir då oppskalerte med kvadratet av dette.
\ Kvalitetslikningane må oppskalerast tilsvarande og vidare med 
\ 100 eller 1000 på høgresida for å få vektskoeffisientane over null.

\ Lengdefeillikning
\ v=ax1-by1-ax2+by2+(Lprov-Lmålt)
\ v er funksjon av 4 element, xy-koo i kvar ende av lengden
\ og diff mellom målt L og L utrekna av provisoriske koo
\ etal er antal element, f er konstanledd (Lprov -Lmålt)

\ Feillikningar struktur ----------------------------------
\    	   0    1    2    3    4
\ IN{	| ex | ey | ex | ey |  -3  | etal |
\ FE{	| a1 | b1 | a2 | b2 |      |  f   |

testing [IF]

: .fe1 ( -- ) \ ein f-likn - grunnlaget for akkumulering
	CR #ko 0 DO
		IN{ I } @ 12 .R		\ indeksar=elementnr
	LOOP
	CR #ko 0 DO
		FE{ I } @ 12 .R		\ koeffisientar
	LOOP ;

: .fe3 ( -- ) \ ein f-likn - grunnlaget for akkumulering
	CR \ Pvekt @ 3 .R   
	#ko 0 DO             \ utan indeksar
		FE{ I } @ 12 .R		\ koeffisientar
	LOOP ;
[THEN]

\ Feillikningar koeffisientar. -------------------

: LengdeKoeff ( -- a b )
	cos0 2@ swap +skaler swap /
	sin0 2@ swap +skaler swap / ;

\ Feillikningar konstantledd. -------------------

: LengdeKonst ( snr -- konstantledd )
	LS{ over } @  VV{ rot } @  horisontrer
	L0 @ ( swap ) - ;
	
: LengdeLiknH ( snr -- hledd ) \ høgresideledd=konstantledd*skala
	LengdeKonst ( +skaler ) ;

\ Feillikningar: Indeksar: 2 pr nypkt + 1 pr stasjon-
\ gi elementnr. Gitte element får negative nr
: elementnr2 ( pnr - ex ey )
   NYPNR{ SWAP } @            \ nypkt får 0 1 2 3 osv
   2 * DUP  2 - SWAP 1 - ;    \ gitt punkt (nypkt=0) får -2 -1
   
: ElementFra ( siktnr -- ex ey )
	frapkt ( pnr )  elementnr2 ;

: ElementTil ( siktnr -- ex ey )
	tilpkt ( pnr )  elementnr2 ;

: ElementOe ( siktnr -- ez )       \ elementnr for or.elementet
	ORNR{ swap } @ ntal2 @ 2*  + ; \ sikt utan stasjon ????????

: elementnr1 ( pnr - eh )
   NYPNR{ SWAP } @            \ nypkt får elementnr 0 1 2 3 osv
    1 - ;                     \ gitt punkt (nypktnr=0) får  -1

: ElementFraH ( siktnr -- eh )
	frapkt ( pnr )  elementnr1 ;

: ElementTilH ( siktnr -- eh )
	tilpkt ( pnr )  elementnr1 ;

\ -----------------------------------------------------

: DannIndeksar ( siktnr -- )
	dup ElementFra ( s ex1 ey1 ) IN{ 1 } ! IN{ 0 } ! ( s )
	ElementTil ( ex2 ey2 )       IN{ 3 } ! IN{ 2 } ! 
	etal @                       IN{ 5 } ! ;   \ antal element
	
: xyLikning ( snr -- )
	0feillikn  DannIndeksar ;

: DannIndeksarH ( siktnr -- )
	dup ElementFraH ( s eh1 ) IN{ 0 } ! ( s )
	ElementTilH ( eh2 )       IN{ 1 } ! 
	etal @                    IN{ 2 } ! ;   \ antal element

: DannLengdelikning ( snr -- )
	dup xyLikning
	LengdeKoeff   ( snr a b )    !KooKoeffL   \ til FE{ 0-3
	LengdeLiknH  +skaler         FE{ 5 } !  (  )
	-3  ( negativ=udefinert )    IN{ 4 } !                    \   .fe3 
	;

: DannRetningsLikning ( snr -- )
	dup xyLikning
	RetningsKoeff                    !KooKoeffR   \ til FE{ 0-3
	-1  +skaler ( oe-koeffisient )   FE{ 4 } !
	dup RetningsKonst  +skaler       FE{ 5 } !
	ElementOe                        IN{ 4 } !                 \  .fe3 
	;

: DannHlikning ( snr -- )
	0feillikn
	dup siktdatah ( snr z0 koeff )  dup FE{ 0 } ! negate  FE{ 1 } ! ( snr z0 )
	over VV{ swap } @ swap - ( z-z0 )  +skaler  FE{ 2 } !
	DannIndeksarH ; \                               .fe3 key drop ;

\ -----------------------------------------------------
