\ Normallikningane er akkumulerte i N1{{
\ Dei blir henta derfrå til A{{ og B{ , oppstilt for gauss-løysing
\ Løysinga er koo-forbetringar som blir påførte dei provisoriske koo.

VARIABLE #u	\ antal ukjente
\ Normallikningar, dynamiske matriser-------------------------- 

INTEGER DMATRIX A{{        \ vside
INTEGER DARRAY  B{         \ hside
INTEGER DARRAY  X{         \ resultat ( svar )
: -Gauss  & X{ }free & B{ }free & A{{ }}free ; \ frigjer (steng) plass
: +Gauss ( #u -- )   \ reservering av plass for normallikningane
    & A{{ OVER DUP }}malloc  malloc-fail? ABORT" A-malloc failed"
    & B{ OVER  }malloc  malloc-fail? ABORT" B-malloc failed" 
    & X{ OVER  }malloc  malloc-fail? ABORT" X-malloc failed" 
	CR ." Gauss heiltal trad. " . ." ukjente" ;

\ --------------------------------------------start gauss ----------
\ Feillikningskoeffisientane er skalerte med os
: 0X   ( -- ) #u @ 0 DO   0 X{ I } !   LOOP ;	\ nullstill

testing [IF]
: .X   ( -- )   \ skriv svar-vektor
    CR  #u @ 0 DO  X{ I } ?    LOOP ;

: .nor ( - ) CR ." Normallikningar i A"
	#u @  0 DO CR ." |"
		#u @  0 DO
			A{{ J I }} @ 14 .R   \ venstreside
		LOOP
		."  |   |" B{ I } @ 14 .R   ."  |"    \ h¿greside
	LOOP ;
	
: .nor1 ( - ) CR ." Normallikningar i A-B" \ brei tabell med xy
	#u @  0 DO CR ." |"
		#u @  0 DO
			A{{ J I }} @ 6 .R   \ venstreside
		LOOP
		."  |   |" B{ I } @ 10 .R   ."  |"    \ h¿greside
		X{ I } ?
	LOOP ;
	
: .nor2 ( - ) CR ." Normallikningar" \ tabellhjørne med xy
	#u @  DUP 10 - DO CR ." |"
		#u @ DUP 10 - DO
			A{{ J I }} @ 8 .R   \ venstreside
		LOOP
		."  |   |" B{ I } @ 12 .R   ."  |"    \ h¿greside
		X{ I } ?
	LOOP ;

[THEN]

: 1ukjent ( -- )
	B{ 0 } @  A{{ 0 0 }} @  /  X{ 0 } ! ;

\ ------------------------------løysing av likningane-----------------------
2VARIABLE multiplier   \ multiplier, stored as a fraction
0 VALUE L   0 VALUE M   0 VALUE N \ for 3 nested loops

: backsub   \ algo2.1 \ back subst
	0X
    0 #u @ 1 - DO
        #u @ I  DO
            B{ J } @ X{ I } @ A{{ J I }} @ * - B{ J } !
        LOOP
         B{ I } @ A{{ I I }} @ / X{ I } !                \  .nor1 key drop
    -1 +LOOP ;
	
\ -------------alt 1 - tradisjonell 2loop---------------------------

: ResizeElement  ( n -- n2 ) \ using the multiplikator
    multiplier 2@ ( n tel nev )
    */  ;   
	
: Multiplier!   ( -- )   \ store the multiplier as a fraction
	A{{ M L }} @   A{{ L L }} @        \  2dup cr . .         
	multiplier 2! ;

: ConvertRight   ( -- )
	B{ M } @   B{ L } @       ResizeElement  - B{ M } ! ; 
	
: ConvertElement   ( -- ) 
	A{{ M N }} @   A{{ L N }} @   ResizeElement   -   A{{ M N }} ! ;

: ConvertLeft   ( -- )
	#u @ 0   DO   I TO N
		ConvertElement
	LOOP ;

: MakeTriangular ( -- )
   #u @ 1- 0 DO   I TO L		\ outer LOOP, selecting upper row
      #u @ I 1+ DO  I TO M		\ mid LOOP, selecting lower row
         Multiplier!				\ find and store the multiplier
         ConvertRight				\ no LOOP needed
		 ConvertLeft				\ inner LOOP
    LOOP 
   LOOP                          ( .nor1 key drop ) ;
   
: gauss  ( n -- )   \ svar i X{
	dup #u !
	1 = IF
		1ukjent
	ELSE
		MakeTriangular  backsub 
	THEN ;

\ -----------------------------------------------------slutt gauss---------------
\ bevar N1 uendra, kopi i A og B blir brukt til å løysa

: HentKopiV   ( -- )	\ til A
	etal @ 0 DO
		etal @ 0 DO
			N1{{ I J }} @   A{{ I J }} !
		LOOP
	LOOP ;

: HentKopiH   ( -- )	\ til B
	etal @ 0 DO
		N1{{ I etal @ }} @  ( dup . ) B{ I } ! 
	LOOP ;

: FinnSvar1  ( -- )   \ svar i X{
	HentKopiV HentKopiH
	etal @ gauss ;

