

: radius@ ( a -- R ) @ ;
: sentrum@ ( a -- x y ) 3@ DROP ;

\ ----------------------drmath--------------------
VARIABLE grunnlinje     \ avstand
2VARIABLE grunnlinje2   \ avstand*avstand
2VARIABLE dxdy          \ koodiff sentrum-sentrum
2VARIABLE skj0          \ relevant skjpkt
2VARIABLE skj1          \ løysing 1
2VARIABLE skj2          \ løysing 2

VARIABLE abscisse   \ sentrum-fotpunkt
VARIABLE ordinat    \ fotpunkt-skj

: basis ( pkt0 . pkt1 . -- )
	k-diff 2dup dxdy 2! ( dx dy )
	hypotenus2 ( hypo hypo2 . )
	grunnlinje !   grunnlinje2 2! ;

: langs ( grunnlinje2 r0 r1 -- )  \ sentrum-fotpunkt
    SWAP
    DUP M*   ROT
    DUP M*   D-
    D+
    grunnlinje @ 2 *   (FM/)   abscisse ! ;
    
: tvers ( r0 -- )   \ fotpunkt-skj
    abscisse @ SWAP DUP M*
    ROT DUP M* D-
	abscisse @ ( d rot0 ) kvrot2
	ordinat ! ;

: gl-div ( x y n -- x y ) DUP grunnlinje @ DUP k*/ ;

: tilvekst1 ( dx dy -- x y )    \ sentrum-fotpunkt
    abscisse @ ( dx dy a ) gl-div ;
    
: tilvekst2 ( dx dy -- x y )    \ fotpunkt-skj
    SWAP
    ordinat @ ( dy dx o ) gl-div ;

: 2skj ( pkt0 . -- ) \ skjæring med to løysingar
    dxdy 2@   tilvekst1  k+      \ fotpunkt
    2DUP
    dxdy 2@      NEGATE      tilvekst2   k+  skj1 2!
    dxdy 2@ SWAP NEGATE SWAP tilvekst2   k+  skj2 2! ;
\ --------------------------------------------------    
3variable sirkel0
3variable sirkel1
3variable sirkel2

: radier@ ( -- R0 R1 ) sirkel0 radius@   sirkel1 radius@ ;

: feilkvadrat ( x y -- vv ) \ avvik mellom xy og sirkel2
    sirkel2 sentrum@ k- ( dx dy )
	hypotenus3  sirkel2 radius@ -   DUP * ;
	
: sirkel2test ( -- vv1 vv2 ) \ avstand xy-sirkel2
    skj1 2@ feilkvadrat
    skj2 2@ feilkvadrat ;

: likskap? ( vv1 vv2 -- f )  \ like eller nesten like
	- abs 10 < ;
	
: skjbest ( vv1 vv2 -- )
	> IF   skj2 2@   ELSE   skj1 2@   THEN
	skj0 2! ;
	
: autoval  ( -- f ) \ f=0 ved uavgjort
	sirkel2test ( vv1 vv2 )
	2dup likskap? if 2drop 0 else
	skjbest 1 then ;

: ekstrembasis? ( -- flagg )
    grunnlinje @ radier@ ( g R0 R1 ) + > IF ."  For lang" -1   EXIT then
    grunnlinje @ radier@  - ABS < IF ."  For kort" -1   EXIT then
    grunnlinje @ radier@ = SWAP 0= AND IF ."  Null" -1   EXIT then
    0 ;

: skj ( -- antall )  \ 0/2 løysingar
    sirkel0 sentrum@   sirkel1 sentrum@  basis
    ekstrembasis? IF 0 EXIT THEN
    grunnlinje2 2@   sirkel0 radius@ sirkel1 radius@ langs
    sirkel0 radius@   tvers
    ordinat @ 0 < IF ." Ikkje skjæring" 0 EXIT THEN
    sirkel0 sentrum@   2skj 2 ;

: 1eller2 ( -- n )  \ krev tast 1 eller 2
    cr ." Tast 1 eller 2:"
    BEGIN
        KEY DUP DUP ( c c c )
        49 < SWAP 50 > OR
    WHILE
        DROP
    REPEAT
    48 - dup . ;

: .xymeter ( x'y' -- ) \ til ekte og heile meter
	x'y'>xy presisjonm @ fix0 
	   swap presisjonm @ fix0 swap k. ;

: vis2 ( -- )
    cr ." Skj1= "  skj1 2@ .xymeter
    cr ." Skj2= "  skj2 2@ .xymeter ;

: manuell ( -- )    \ val av interessant skjpkt
    vis2   1eller2
    2 = IF   skj2 2@   ELSE   skj1 2@   THEN 
    skj0 2! ;

: reduser ( -- n )  \ reduser antall skjpkt frå 2 til 1
    ordinat @ 0= IF 0 0 skj2 2!   1 EXIT THEN   \ tangering
    sirkel2 radius@ IF 
		autoval ( 0 eller 1 )  \  0=uavgjort, inga løysing 
	ELSE 
		manuell 1
	THEN ;

: sirkelskj ( -- n )    \ 0/1 løysingar
    skj ( n )
    DUP 2 = IF DROP reduser THEN ;

: trilati ( x y r x y r x y r -- x y )  \ sirkel0 sirkel1 sirkel2 -- skjpkt
    sirkel2 3!   sirkel1 3!   sirkel0 3!
    sirkelskj ( 0/1 )
    IF   skj0 2@   ELSE   0 0   THEN ;
    
\ 2238 7124 1323   \ sirkel0
\ 2005 8067 1217 \ sirkel1
\ 2320 8897 1322 \ sirkel2 
  \ sirkel2 3!   sirkel1 3!   sirkel0 3!

: autoval+ ( -- 0/1 )
	sirkel2 radius@ IF
		autoval
	ELSE
		autofleirsikt
	THEN

