#!/usr/bin/wish

package require Tk

#Hovudvindu med knappar og listeramme, venstreside av skjerm
wm title . "HANAKAM"
wm geometry . 400x620+100+100          ;#bxh motH ned
# Liste
grid [tk::listbox .liste \
	-yscrollcommand ".s1 set" -xscrollcommand ".s2 set" \
	-height 25 -width    60] -column 0 -row 0 -sticky nwes
grid [ttk::scrollbar .s1 -command ".liste yview" -orient vertical \
   ] -column 1 -row 0 -sticky ns
grid [ttk::scrollbar .s2 -command ".liste xview" -orient horizontal \
   ] -column 0 -row 1 -sticky ew

# Rammer
frame .rame1 -width 400 -height 100 -borderwidth 5 -relief raised
grid .rame1  -column 0 -row 2

frame .rame2 -width 400 -height 100 -borderwidth 5 -relief raised
grid .rame2  -column 0 -row 3

# Knappar ramme 2
button .rame2.zoominn -text "Zoom+"    -command ZoomInn
button .rame2.zoomut  -text "Zoom-"    -command ZoomUt
# button .rame2.utjamn  -text "Provi"   -command Pro
button .rame2.rapport -text "Rapport"  -command Rapport
grid .rame2.zoominn -row 2 -column 0 -sticky w
grid .rame2.zoomut -row 2 -column 1 -sticky w
# grid .rame2.utjamn -row 2 -column 2 -sticky w
grid .rame2.rapport -row 2 -column 2 -sticky w

# Knappar ramme 1
button .rame1.inn -text "Prosjekt..."   -command VisProsjekt
button .rame1.ut  -text "Avslutt"       -command exit
grid .rame1.inn -row 2 -column 0 -sticky w
grid .rame1.ut -row 2 -column 1 -sticky e

#Kartvindu (k)
toplevel .k
wm title .k "Plott-provisorisk"
wm geometry .k 500x500-100+100
canvas .k.canvas -scrollregion "-1000 -1000 1000 1000" -yscrollcommand ".k.v set" -xscrollcommand ".k.h set"
grid  .k.canvas  -sticky nwes -column 0 -row 0
grid columnconfigure .k 0 -weight 1
grid rowconfigure .k 0 -weight 1

grid [scrollbar .k.h -orient horizontal -command ".k.canvas xview"] -column 0 -row 1 -sticky we
grid [scrollbar .k.v -orient vertical -command ".k.canvas yview"] -column 1 -row 0 -sticky ns

#Rapportvindu (rvindu) er definert i Proc/Rapportvindu

#####################
proc ZoomInn { } {
.k.canvas scale all 250 250 1.4 1.4
}
proc ZoomUt { } {
.k.canvas scale all 250 250 0.7 0.7
}

# fila inneheld prosjektsti
# filb inneheld provisorisk maxmin, antall og pxy
# filc inneheld antall og xyxy for strek
# result innheld resultata
# filene er plasserte i ~ av forth-programmet
# forth-programmet er /home/jostein/arbeid/Tnett/last8080.fth
# kartvindu er 500x500
#
proc VisProsjekt { } {
	set prosjektsti [FinnProsjekt]
	if {
		$prosjektsti != ""
	} then {
		.k.canvas delete all       ;# slett plotteramme
#		.k.canvas -scrollregion "-1000 -1000 1000 1000" -yscrollcommand ".k.v set" -xscrollcommand ".k.h set"
		#Køyr Forth og lag filer med tolka inndata
		tforth                     ;# køyr Tnett
		#filb er nå oppretta
		LesKoo                     ;# og vis koo
		LesSikt                    ;# og vis sikt
		.liste insert end  "Ferdig"      ;#skriv til liste
	}
}
proc Rapport { } {
	set fidd [open ~/hanakam/result.txt r]
	set rapp [read $fidd]
	Rapportvindu
	.rvindu.frame.canvas create text 1 1 -text $rapp -anchor nw -font TkFixedFont
	button .rvindu.ok -text Lukk -default active -command {destroy .rvindu}
	button .rvindu.ut -text "Lagr som..." -default active -command Lagr
	pack .rvindu.ok -side right -fill x
	pack .rvindu.ut -side left -fill x
	close $fidd
}
proc FinnProsjekt { } {
	set prosjektsti [Prosjekt ]
	if {
		$prosjektsti > ""
	} then {
		LagrSti $prosjektsti        ;   # i fil a
	}	
	return $prosjektsti
}
proc LesKoo { } {
	set fidb [open ~/hanakam/tempo/filb.txt r]   ;#Opn koofil
	#les koo-linjer frå filb, skriv til listeramme
	gets $fidb koolinje                    ;#hent rad 1
	set antal [lindex $koolinje 4]         ;#hent antal frå kolonne 4
	set maxmin [lrange $koolinje 0 3]      ;#hent min og max frå kolonne 0-3
	Konstantar $maxmin 500 500             ;#rekn transformasjon
	for {set x 1} {$x <= $antal} {incr x} {
		gets $fidb koolinje                ;#les tabell-linje frå filb
		.liste insert end  $koolinje       ;#skriv til liste
		Plott $koolinje
	}
	close $fidb                            ;# Lukk koofil
}
proc LesSikt { } {
	set fidc [open ~/hanakam/tempo/filc.txt r]   ;#Opn siktfil
	gets $fidc siktlinje                   ;#hent rad 1
	set antal [lindex $siktlinje 0]        ;#hent antal frå rad 1 kolonne 0
	for {set x 1} {$x <= $antal} {incr x} {
		gets $fidc siktlinje               ;#les tabell-linje frå filc
#		.liste insert end  $siktlinje      ;#skriv sikt til liste
		PlottStrek $siktlinje              ;#skriv sikt til plott
	}
	close $fidc                            ;# Lukk siktfil
}
########################## exec gforth #############################
proc tforth { } {
	file delete /home/jostein/hanakam/tempo/result.txt               ;#Slett resultatfil
	exec gforth /home/jostein/hanakam/last9082gf3264.fth -e start > /home/jostein/hanakam/tempo/result.txt -e bye  &
	after 1000 set state timeout
	vwait state
	.liste insert end  "Provisoriske (filb):"      ;#skriv til liste
}

################################### Prosjektfil ###################
proc Prosjekt { } {
	#vel datafil, utan å opna
	set types {
        {{Prosjektfiler } {.pxt}}
	{{Tekstfiler } {.txt}}
	{{Alle filer} *}
	}
	# datafil=sti 
	set prosjektsti [tk_getOpenFile -filetypes $types -initialdir /home/jostein/hanakam/demo]
	return $prosjektsti
}
proc LagrSti { prosjektsti } {
	# Opne fila, stifil, fida
	set fida [open /home/jostein/hanakam/tempo/fila.txt w+]
	# Lagr datafilsti i fila
	puts $fida $prosjektsti
	close $fida
}

######################### målestokk ###############

proc Konstantar { maxmin b h} {
	set skjermmidt [Midt $maxmin]
	global mstokk
	set mstokk [Målestokk $maxmin $b $h]
}
proc Midt { maxmin } {
	set xmin [ lindex $maxmin 0]
	set xmax [ lindex $maxmin 1]
	set ymin [ lindex $maxmin 2]
	set ymax [ lindex $maxmin 3]
	global xm
	global ym
	set xm [expr ($xmin + $xmax)/2]
	set ym [expr ($ymin + $ymax)/2]
	set xmym [list $xm $ym]
	return $xmym
}
proc Målestokk { maxmin b h} {
	set xmin [ lindex $maxmin 0]
	set xmax [ lindex $maxmin 1]
	set ymin [ lindex $maxmin 2]
	set ymax [ lindex $maxmin 3]
	set dx [expr $xmax - $xmin]
	set dy [expr $ymax - $ymin]
	set mx [expr ($dx/($h-10)+1)]
	set my [expr ($dy/($b-10)+1)]
	set mstokk [expr {max ($mx, $my)}]
	return $mstokk
}
proc Plott { koolinje } {
	set x [lindex $koolinje 1]
	set y [lindex $koolinje 2]
	set id [lindex $koolinje 0]
	OmreknPkt $x $y $id
}
proc PlottStrek { siktlinje } {
	set x1 [lindex $siktlinje 0]
	set y1 [lindex $siktlinje 1]
	set x2 [lindex $siktlinje 2]
	set y2 [lindex $siktlinje 3]
	set p1 [OmreknXY $x1 $y1]
	set p2 [OmreknXY $x2 $y2]
	.k.canvas create line "$p1 $p2" -fill blue
}
proc OmreknPkt { x y id} {
	set x [string map {, .} $x]
	set y [string map {, .} $y]
	global xm
	global ym
	global mstokk
	set xs [expr ($y-$ym)/$mstokk +250]
	set ys [expr (-$x+$xm)/$mstokk +250]
	Punkt $id $xs $ys
}
proc OmreknXY { x y } {
	set x [string map {, .} $x]
	set y [string map {, .} $y]
	global xm
	global ym
	global mstokk
	set xs [expr ($y-$ym)/$mstokk +250]
	set ys [expr (-$x+$xm)/$mstokk +250]
	return "$xs $ys"
}
proc Punkt { id x y } {
set a [expr ($x-3)]
set b [expr ($y-3)]
set c [expr ($x+3)]
set d [expr ($y+3)]
.k.canvas create oval $a $b $c $d -fill green
.k.canvas create text $a $b -anchor e -text $id
}
#Scrolling

proc moveity2 {args} {
        eval ".rvindu.frame.canvas yview $args"
        set nowat [.rvindu.frame.canvas yview]
        eval ".rvindu.frame.right set $nowat"
        }

# Resultat og rapport

proc Rapportvindu { } {
	toplevel .rvindu
	frame .rvindu.frame
	#wm geometry .extra 500x500+700+100
	wm title .rvindu "Rapport"
	canvas .rvindu.frame.canvas -width 650 -height 500 \
        -scrollregion {0 0 900 5000} -bg grey
	#scrollbar .rvindu.frame.base -orient horizontal \
	#        -command moveitx
	scrollbar .rvindu.frame.right -orient vertical \
        -command moveity2
	label .rvindu.frame.corner -text X
	#.rvindu.frame.base set 0 0.75
	.rvindu.frame.right set 0 0.5

	pack .rvindu.frame -fill both -expand true
	grid .rvindu.frame.canvas .rvindu.frame.right -sticky news
	#grid .rvindu.frame.base .rvindu.frame.corner -sticky news
}
proc Lagr { } {
	set types {
	{{Tekstfiler } {.txt}}
	{{Alle filer} *}
	}
	set filename [tk_getSaveFile -filetypes $types \
		-defaultextension txt -initialfile rapport.txt -initialdir ~/hanakam/]
	if {$filename ne ""} {
		file copy -force ~/hanakam/tempo/result.txt $filename
	}
}
